/* This file is part of the avgbs2txt project.
 * For more information, please see <http://www.eisenhutinformatik.ch/avgbs2txt/>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package ch.ehi.avgbs2txt.gui;

import java.util.ArrayList;
import ch.ehi.basics.logging.EhiLogger;
import ch.ehi.basics.view.*;
import ch.ehi.basics.swing.SwingWorker;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

/** GUI.
 * @author ce
 * @version $Revision: 1.0 $ $Date: 10.02.2005 $
 */
public class MainFrame extends JFrame {

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JLabel jLabel = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JTextField avgbsFileUi = null;
	private javax.swing.JTextField txtFileUi = null;
	private javax.swing.JTextArea logUi = null;
	private javax.swing.JButton clearlogBtn = null;
	/**
	 * This is the default constructor
	 */
	public MainFrame() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(314, 361);
		this.setContentPane(getJContentPane());
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setName("avgbs2txt");
		this.setTitle("avgbs2txt");
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			java.awt.GridBagConstraints consGridBagConstraints3 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints2 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints4 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints5 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints19 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints31 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints113 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints21 = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagConstraints1 = new java.awt.GridBagConstraints();
			consGridBagConstraints21.gridx = 2;
			consGridBagConstraints21.gridy = 1;
			consGridBagConstraints1.gridx = 2;
			consGridBagConstraints1.gridy = 0;
			consGridBagConstraints113.gridy = 12;
			consGridBagConstraints113.gridx = 2;
			consGridBagConstraints31.weightx = 1.0;
			consGridBagConstraints31.weighty = 1.0;
			consGridBagConstraints31.fill = java.awt.GridBagConstraints.BOTH;
			consGridBagConstraints31.gridx = 0;
			consGridBagConstraints31.gridy = 12;
			consGridBagConstraints31.gridheight = 2;
			consGridBagConstraints31.gridwidth = 2;
			consGridBagConstraints5.weightx = 1.0;
			consGridBagConstraints5.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints5.gridx = 1;
			consGridBagConstraints5.gridy = 1;
			consGridBagConstraints5.anchor = java.awt.GridBagConstraints.NORTHWEST;
			consGridBagConstraints4.weightx = 1.0;
			consGridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints4.gridx = 1;
			consGridBagConstraints4.gridy = 0;
			consGridBagConstraints4.anchor = java.awt.GridBagConstraints.NORTHWEST;
			consGridBagConstraints19.gridx = 2;
			consGridBagConstraints19.gridy = 13;
			consGridBagConstraints19.anchor = java.awt.GridBagConstraints.NORTH;
			consGridBagConstraints3.gridx = 0;
			consGridBagConstraints3.gridy = 1;
			consGridBagConstraints3.anchor = java.awt.GridBagConstraints.NORTHWEST;
			consGridBagConstraints2.gridx = 0;
			consGridBagConstraints2.gridy = 0;
			consGridBagConstraints2.anchor = java.awt.GridBagConstraints.NORTHWEST;
			jContentPane.setLayout(new java.awt.GridBagLayout());
			jContentPane.add(getJLabel(), consGridBagConstraints2);
			jContentPane.add(getJLabel1(), consGridBagConstraints3);
			jContentPane.add(getAvgbsFileUi(), consGridBagConstraints4);
			jContentPane.add(getTxtFileUi(), consGridBagConstraints5);
			jContentPane.add(getJScrollPane(), consGridBagConstraints31);
			jContentPane.add(getClearlogBtn(), consGridBagConstraints19);
			jContentPane.add(getDoConvertBtn(), consGridBagConstraints113);
			jContentPane.add(getDoAvgbsFileSelBtn(), consGridBagConstraints1);
			jContentPane.add(getDoTxtFileSelBtn(), consGridBagConstraints21);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText("avgbsFile");
		}
		return jLabel;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if(jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText("txtFile");
		}
		return jLabel1;
	}
	/**
	 * This method initializes avgbsFileUi
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getAvgbsFileUi() {
		if(avgbsFileUi == null) {
			avgbsFileUi = new javax.swing.JTextField();
		}
		return avgbsFileUi;
	}
	/**
	 * This method initializes txtFileUi
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getTxtFileUi() {
		if(txtFileUi == null) {
			txtFileUi = new javax.swing.JTextField();
		}
		return txtFileUi;
	}
	/**
	 * This method initializes logUi
	 * 
	 * @return javax.swing.JTextArea
	 */
	private javax.swing.JTextArea getLogUi() {
		if(logUi == null) {
			logUi = new javax.swing.JTextArea();
			logUi.setEditable(false);
		}
		return logUi;
	}
	/**
	 * This method initializes clearlogBtn
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getClearlogBtn() {
		if(clearlogBtn == null) {
			clearlogBtn = new javax.swing.JButton();
			clearlogBtn.setText("clear log");
			clearlogBtn.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					logClear();
				}
			});
		}
		return clearlogBtn;
	}
	public String getAvgbsFile(){
		return strip(getAvgbsFileUi().getText());
	}
	public void setAvgbsFile(String dbhost){
		getAvgbsFileUi().setText(dbhost);
	}
	public String getTxtFile(){
		return strip(getTxtFileUi().getText());
	}
	public void setTxtFile(String dbport){
		getTxtFileUi().setText(dbport);
	}
	private StringBuffer body=new StringBuffer();
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JButton doConvertBtn = null;
	private javax.swing.JButton doAvgbsFileSelBtn = null;
	private javax.swing.JButton doTxtFileSelBtn = null;
	public void logAppend(String msg){
		body.append(msg);
		if(!msg.endsWith("\n")){
			body.append("\n");
		}
		getLogUi().setText(body.toString());
	}
	public void logClear(){
		body=new StringBuffer();
		getLogUi().setText(body.toString());
	}
	/**
	 * This method initializes jScrollPane
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if(jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getLogUi());
		}
		return jScrollPane;
	}
	/** removes leading and trailing white space and returns null if nothing left.
	 */
	private static String strip(String value){
		String ret=value.trim();
		if(ret.length()==0){
			return null;
		}
		return ret;
	}
	public static void main(String avgbsFile,String txtFile) {
		MainFrame frame=new MainFrame();
		EhiLogger.getInstance().addListener(new LogListener(frame));
		if(avgbsFile!=null){
			frame.setAvgbsFile(avgbsFile);
		}
		if(txtFile!=null){
			frame.setTxtFile(txtFile);
		}
		frame.show();
	}
	/**
	 * This method initializes doConvertBtn
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getDoConvertBtn() {
		if(doConvertBtn == null) {
			doConvertBtn = new javax.swing.JButton();
			doConvertBtn.setText("convert");
			doConvertBtn.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(ch.ehi.basics.view.FileChooser.approveFile(getTxtFile(),MainFrame.this,ch.ehi.avgbs2txt.Main.APP_NAME)){
						SwingWorker worker = new SwingWorker() {
							public Object construct() {
								try {
									ch.ehi.avgbs2txt.Main.runExport(
										getAvgbsFile(),
										getTxtFile()
									);
								}
								catch (Exception ex) {
									EhiLogger.logError("export failed",ex);
								}
								return null;
							}
						};
						worker.start();
					}
				}
			});
		}
		return doConvertBtn;
	}
	/**
	 * This method initializes doAvgbsFileSelBtn
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getDoAvgbsFileSelBtn() {
		if(doAvgbsFileSelBtn == null) {
			doAvgbsFileSelBtn = new javax.swing.JButton();
			doAvgbsFileSelBtn.setText("...");
			doAvgbsFileSelBtn.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					String file=getAvgbsFile();
					FileChooser fileDialog =  new FileChooser(file);
					fileDialog.setDialogTitle("Open AVGBS file");
					fileDialog.addChoosableFileFilter(new GenericFileFilter("INTERLIS 2 transfer file (*.xtf)","xtf"));
					fileDialog.addChoosableFileFilter(GenericFileFilter.createXmlFilter());

					if (fileDialog.showOpenDialog(MainFrame.this) == FileChooser.APPROVE_OPTION) {
						file=fileDialog.getSelectedFile().getAbsolutePath();
						setAvgbsFile(file);
					}					
				}
			});
		}
		return doAvgbsFileSelBtn;
	}
	/**
	 * This method initializes doTxtFileSelBtn
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getDoTxtFileSelBtn() {
		if(doTxtFileSelBtn == null) {
			doTxtFileSelBtn = new javax.swing.JButton();
			doTxtFileSelBtn.setText("...");
			doTxtFileSelBtn.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					String file=getTxtFile();
					FileChooser fileDialog =  new FileChooser(file);
					fileDialog.setDialogTitle("Open text file");
					fileDialog.addChoosableFileFilter(new GenericFileFilter("Text file (*.txt)","txt"));

					if (fileDialog.showSaveDialog(MainFrame.this) == FileChooser.APPROVE_OPTION) {
						file=fileDialog.getSelectedFile().getAbsolutePath();
						setTxtFile(file);
					}					
				}
			});
		}
		return doTxtFileSelBtn;
	}
}  //  @jve:visual-info  decl-index=0 visual-constraint="20,41"
